=== debian/changelog ===
golang-github-evanw-esbuild (0.11.16-1) unstable; urgency=medium

  * New upstream version 0.11.16
  * Bump Standards-Version to 4.6.0 (no change)
  * Mark library package with "Multi-Arch: foreign"
  * Update esbuild(1) man page to 0.11.16
  * Remove scripts/fuzzer/escodegen.js entry from debian/copyright.
    Upstream "delete[d] the fuzzer that doesn't work anymore" in v0.11.11

 -- Anthony Fok <foka@debian.org>  Fri, 15 Oct 2021 05:34:50 -0600

golang-github-evanw-esbuild (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6
  * debian/watch: Use api.github.com to fetch older versions
    such as v0.9.6 which is no longer listed on the first page
    of https://github.com/gohugoio/hugo/tags
  * Update esbuild(1) man page to 0.9.6

 -- Anthony Fok <foka@debian.org>  Sat, 14 Aug 2021 13:53:08 -0600

golang-github-evanw-esbuild (0.8.46-2) unstable; urgency=medium

  * Update esbuild(1) man page to 0.8.46

 -- Anthony Fok <foka@debian.org>  Sat, 14 Aug 2021 02:53:03 -0600

golang-github-evanw-esbuild (0.8.46-1) unstable; urgency=medium

  * New upstream version 0.8.46

 -- Anthony Fok <foka@debian.org>  Mon, 09 Aug 2021 00:00:32 -0600
