## golang-github-evanw-esbuild 0.12.17

=== debian/changelog ===
golang-github-evanw-esbuild (0.12.17-1) unstable; urgency=medium

  * New upstream version 0.12.17
  * Update esbuild(1) man page to 0.12.17

 -- Anthony Fok <foka@debian.org>  Fri, 29 Oct 2021 01:36:44 -0600
