=== debian/changelog ===
golang-github-evanw-esbuild (0.12.24-1) unstable; urgency=medium

  * New upstream version 0.12.24
  * Update esbuild(1) man page to 0.12.24

 -- Anthony Fok <foka@debian.org>  Sun, 31 Oct 2021 17:10:34 -0600
