=== debian/changelog ===
golang-github-evanw-esbuild (0.13.12-1) unstable; urgency=medium

  * New upstream version 0.13.12
  * Update esbuild(1) man page to 0.13.12

 -- Anthony Fok <foka@debian.org>  Thu, 04 Nov 2021 10:47:39 -0600
