## golang-github-evanw-esbuild 0.14.2

=== Makefile ===
--- 
+++ 
@@ -10,20 +10,17 @@
 	CGO_ENABLED=0 go build $(GO_FLAGS) ./cmd/esbuild
 
 test:
-	make -j6 test-common
+	@$(MAKE) --no-print-directory -j6 test-common
 
 # These tests are for development
 test-common: test-go vet-go no-filepath verify-source-map end-to-end-tests js-api-tests plugin-tests register-test node-unref-tests
 
 # These tests are for release (the extra tests are not included in "test" because they are pretty slow)
 test-all:
-	make -j6 test-common test-deno ts-type-tests test-wasm-node test-wasm-browser lib-typecheck
-
-# This includes tests of some 3rd-party libraries, which can be very slow
-test-prepublish: check-go-version test-all test-preact-splitting test-sucrase bench-rome-esbuild bench-readmin-esbuild test-esprima test-rollup
+	@$(MAKE) --no-print-directory -j6 test-common test-deno ts-type-tests test-wasm-node test-wasm-browser lib-typecheck
 
 check-go-version:
-	@go version | grep ' go1\.17\.2 ' || (echo 'Please install Go version 1.17.2' && false)
+	@go version | grep ' go1\.17\.4 ' || (echo 'Please install Go version 1.17.4' && false)
 
 # This "ESBUILD_RACE" variable exists at the request of a user on GitHub who
 # wants to run "make test" on an unsupported version of macOS (version 10.9).
@@ -60,19 +57,19 @@
 	ESBUILD_BINARY_PATH="$(shell pwd)/esbuild" deno test --allow-run --allow-env --allow-net --allow-read --allow-write --no-check scripts/deno-tests.js
 
 register-test: cmd/esbuild/version.go | scripts/node_modules
-	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild/package.json --version
 	node scripts/register-test.js
 
 verify-source-map: cmd/esbuild/version.go | scripts/node_modules
-	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild/package.json --version
 	node scripts/verify-source-map.js
 
 end-to-end-tests: cmd/esbuild/version.go | scripts/node_modules
-	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild/package.json --version
 	node scripts/end-to-end-tests.js
 
 js-api-tests: cmd/esbuild/version.go | scripts/node_modules
-	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild/package.json --version
 	node scripts/js-api-tests.js
 
 plugin-tests: cmd/esbuild/version.go | scripts/node_modules
@@ -218,7 +215,7 @@
 	rm -f main.*
 
 platform-all: cmd/esbuild/version.go
-	make -j4 \
+	@$(MAKE) --no-print-directory -j4 \
 		platform-windows \
 		platform-windows-32 \
 		platform-windows-arm64 \
@@ -241,8 +238,12 @@
 		platform-deno
 
 platform-windows:
-	cd npm/esbuild-windows-64 && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild-windows-64/package.json --version
 	CGO_ENABLED=0 GOOS=windows GOARCH=amd64 go build $(GO_FLAGS) -o npm/esbuild-windows-64/esbuild.exe ./cmd/esbuild
 
 platform-windows-32:
-	cd npm/esbuild-windows-32 && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/esbuild.js npm/esbuild-windows-32/package.json --version
+	CGO_ENABLED=0 GOOS=windows GOARCH=386 go build $(GO_FLAGS) -o npm/esbuild-windows-32/esbuild.exe ./cmd/esbuild
+
+platform-windows-arm64:
+	node scripts/esbuild.js npm/esbuild-windows-arm64/package.json --version
