=== debian/changelog ===
golang-github-evanw-esbuild (0.14.2-1) unstable; urgency=medium

  * New upstream version 0.14.2
  * Reorder fields in debian/control and debian/copyright as would be
    generated in the next dh-make-golang release after 0.6.0-1
  * Bump dependency on golang-golang-x-sys-dev to
    (>= 0.0~git20210908.aa78b53) as per go.mod since v0.12.26
  * Update esbuild(1) man page to 0.14.2

 -- Anthony Fok <foka@debian.org>  Mon, 06 Dec 2021 09:01:37 -0700
