=== debian/control ===
--- 
+++ 
@@ -1,24 +1,24 @@
 Source: golang-github-evanw-esbuild
+Section: golang
+Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Anthony Fok <foka@debian.org>
-Section: golang
-Testsuite: autopkgtest-pkg-go
-Priority: optional
+Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any (>= 2:1.13~),
-               golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4)
+               golang-golang-x-sys-dev (>= 0.0~git20210908.aa78b53)
+Testsuite: autopkgtest-pkg-go
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild.git
 Homepage: https://github.com/evanw/esbuild
-Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/evanw/esbuild
 
 Package: golang-github-evanw-esbuild-dev
 Architecture: all
 Multi-Arch: foreign
-Depends: golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4),
+Depends: golang-golang-x-sys-dev (>= 0.0~git20210908.aa78b53),
          ${misc:Depends}
 Description: extremely fast JavaScript bundler and minifier (library)
  esbuild is a JavaScript bundler and minifier.  It packages up
