## golang-github-evanw-esbuild 0.14.5

=== debian/changelog ===
golang-github-evanw-esbuild (0.14.5-1) unstable; urgency=medium

  * Use dh-sequence-golang instead of dh-golang and --with=golang
  * New upstream version 0.14.5
  * Update esbuild(1) man page to 0.14.5

 -- Anthony Fok <foka@debian.org>  Fri, 17 Dec 2021 11:41:48 -0700
