=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Anthony Fok <foka@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               dh-golang,
+               dh-sequence-golang,
                golang-any (>= 2:1.13~),
                golang-golang-x-sys-dev (>= 0.0~git20210908.aa78b53)
 Testsuite: autopkgtest-pkg-go
