=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := internal/bundler/snapshots

%:
	dh $@ --builddirectory=_build --buildsystem=golang
