## golang-github-evanw-esbuild 0.14.8

=== Makefile ===
--- 
+++ 
@@ -20,14 +20,25 @@
 	@$(MAKE) --no-print-directory -j6 test-common test-deno ts-type-tests test-wasm-node test-wasm-browser lib-typecheck
 
 check-go-version:
-	@go version | grep ' go1\.17\.4 ' || (echo 'Please install Go version 1.17.4' && false)
-
-# This "ESBUILD_RACE" variable exists at the request of a user on GitHub who
-# wants to run "make test" on an unsupported version of macOS (version 10.9).
-# Go's race detector does not run correctly on that version. With this flag
-# you can run "ESBUILD_RACE= make test" to disable the race detector.
-ESBUILD_RACE ?= -race
-
+	@go version | grep ' go1\.17\.5 ' || (echo 'Please install Go version 1.17.5' && false)
+
+# Note: Don't add "-race" here by default. The Go race detector is currently
+# only supported on the following configurations:
+#
+#   darwin/amd64
+#   darwin/arm64
+#   freebsd/amd64,
+#   linux/amd64
+#   linux/arm64
+#   linux/ppc64le
+#   netbsd/amd64
+#   windows/amd64
+#
+# Also, it isn't necessarily supported on older OS versions even if the OS/CPU
+# combination is supported, such as on macOS 10.9. If you want to test using
+# the race detector, you can manually add it using the ESBUILD_RACE environment
+# variable like this: "ESBUILD_RACE=-race make test". Or you can permanently
+# enable it by adding "export ESBUILD_RACE=-race" to your shell profile.
 test-go:
 	go test $(ESBUILD_RACE) ./internal/...
 
@@ -190,9 +201,7 @@
 	rm -fr e2e-yb
 
 cmd/esbuild/version.go: version.txt
-	# Update this atomically to avoid issues with this being overwritten during use
-	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go.txt
-	mv cmd/esbuild/version.go.txt cmd/esbuild/version.go
+	node scripts/esbuild.js --update-version-go
 
 wasm-napi-exit0-darwin:
 	node -e 'console.log(`#include <unistd.h>\nvoid* napi_register_module_v1(void* a, void* b) { _exit(0); }`)' \
@@ -214,7 +223,7 @@
 	main.bat
 	rm -f main.*
 
-platform-all: cmd/esbuild/version.go
+platform-all:
 	@$(MAKE) --no-print-directory -j4 \
 		platform-windows \
 		platform-windows-32 \
@@ -232,18 +241,17 @@
 		platform-linux-arm64 \
 		platform-linux-mips64le \
 		platform-linux-ppc64le \
+		platform-linux-s390x \
 		platform-sunos \
 		platform-wasm \
 		platform-neutral \
 		platform-deno
 
-platform-windows:
+platform-windows: cmd/esbuild/version.go
 	node scripts/esbuild.js npm/esbuild-windows-64/package.json --version
 	CGO_ENABLED=0 GOOS=windows GOARCH=amd64 go build $(GO_FLAGS) -o npm/esbuild-windows-64/esbuild.exe ./cmd/esbuild
 
-platform-windows-32:
+platform-windows-32: cmd/esbuild/version.go
 	node scripts/esbuild.js npm/esbuild-windows-32/package.json --version
 	CGO_ENABLED=0 GOOS=windows GOARCH=386 go build $(GO_FLAGS) -o npm/esbuild-windows-32/esbuild.exe ./cmd/esbuild
 
-platform-windows-arm64:
-	node scripts/esbuild.js npm/esbuild-windows-arm64/package.json --version
