=== debian/changelog ===
golang-github-evanw-esbuild (0.14.8-1) unstable; urgency=medium

  [ Anthony Fok ]
  * New upstream version 0.14.8
  * Update esbuild(1) man page to 0.14.8

  [ Yadd ]
  * Build and publish nodejs files (Closes: #1001861)

 -- Anthony Fok <foka@debian.org>  Thu, 23 Dec 2021 13:33:25 -0700
