=== debian/control ===
--- 
+++ 
@@ -7,7 +7,10 @@
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-golang,
                golang-any (>= 2:1.13~),
-               golang-golang-x-sys-dev (>= 0.0~git20210908.aa78b53)
+               golang-golang-x-sys-dev (>= 0.0~git20210908.aa78b53),
+               golang-src,
+               nodejs:any,
+               npm,
 Testsuite: autopkgtest-pkg-go
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild
@@ -36,6 +39,9 @@
 Section: javascript
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Provides: node-esbuild (= ${binary:Version}),
+          node-esbuild-wasm (= ${binary:Version}),
+          ${nodejs:Provides}
 Built-Using: ${misc:Built-Using}
 Description: extremely fast JavaScript bundler and minifier (program)
  esbuild is a JavaScript bundler and minifier.  It packages up
